<?php

namespace Teknisa\SM\Controller;

use Teknisa\SM\Controller\SMCrud;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\SM\Service\ValidacoesParametrosFaturamentoService;

class ValidacoesParametrosFaturamentoController extends SMCrud {
    
    protected $service;

    public function __construct($crudService, $environment, ValidacoesParametrosFaturamentoService $validacoesParametrosFaturamentoService) {
        parent::__construct($crudService, $environment);
        $this->service = $validacoesParametrosFaturamentoService;
    }
    
    public function validarSePeriodoDeCompetenciaExiste(Request\Row $request, Response $response) {
        $requestRow = $request->getRow();
        $nrorg = $this->environment->getNrOrg();
        
        $nomeTabela     = $requestRow["NOME_TABELA"];
        $nomeCampoPK    = $requestRow["NOME_CAMPO_PK"];
        $valorCampoPK   = $requestRow["VALOR_CAMPO_PK"];
        $nomeCampoPai   = $requestRow["NOME_CAMPO_PAI"];
        $valorCampoPai  = $requestRow["VALOR_CAMPO_PAI"];
        $nrdiacompetini = $requestRow["NRDIACOMPETINI"];
        $nrdiacompetfin = $requestRow["NRDIACOMPETFIN"];
        $idmescompetini = $requestRow["IDMESCOMPETINI"];
        $idmescompetfin = $requestRow["IDMESCOMPETFIN"];
        
        $diaini = (((int)$idmescompetini - 1) * 31) + $nrdiacompetini;
        $diafin = (((int)$idmescompetfin - 1) * 31) + $nrdiacompetfin;
        
        $existe = $this->service->validarSePeriodoDeCompetenciaExiste($nomeTabela, $nomeCampoPK, $valorCampoPK, $nomeCampoPai, $valorCampoPai, $diaini, $diafin, $nrorg);
        
        $resultdado = new DataSet("resultado", array("existe" => $existe));
        
        $response->addDataSet($resultdado);
    }
}

?>