<?php
namespace Teknisa\SM\Service;

use Doctrine\ORM\EntityManager;
use Teknisa\SM\Factory\Sm00001000PropostaLocalAtendFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;

class Sm00001000PropostaLocalAtendService {
    
    protected $connection;
    protected $factoryLocalAtendProp;
    protected $environment;
    
    public function __construct (EntityManager $entityManager, Sm00001000PropostaLocalAtendFactory $factoryLocalAtendProp, Environment $environment,  NewCode $newCode){
        
        $this->connection             = $entityManager->getConnection();
        $this->factoryLocalAtendProp  = $factoryLocalAtendProp;
        $this->environment            = $environment;
        $this->newCode                = $newCode;

    }
    
        
    /**
     * A função "validaLocalAtend" verifica se o local de Atendimento 
     * que está sendo relacionado já está relacionado na tabela.
     */
     
    public function validaLocalAtend($nrEstruturam, $nrSeqOrcamento){
    
        $params = array(
            "NRORG"          => $this->environment->getNrOrg(),
            "NRSEQORCAMENTO"  => $nrSeqOrcamento,
            "NRESTRUTURAM"   => $nrEstruturam
        );
        
        $return = $this->factoryLocalAtendProp->validaLocalAtend($params);
        return $return[0]["VALIDA"] != 0;
        
    }
    
    /**
     * A função "deletarPaieFilhos" exclui  o local de Atendimento 
     * e os filhos.
     */
    
    public function deletarPaieFilhos($nrEstruturam, $nrSeqOrcamento){
    
        $params = array(
            "NRESTRUTURAM"   => $nrEstruturam,
            "NRSEQORCAMENTO"  => $nrSeqOrcamento,
            "NRORG"          => $this->environment->getNrOrg()
        );
        
        $this->factoryLocalAtendProp->deletarPaieFilhos($params);
    }
}