/******************************************************************************/
/******************************************************************************/
/* Trigger: DTULTATU_VALOROSSA                                                */
/* Tabela : VALOROSSA                                                         */
/* Criao:                                                                   */
/* 14/12/2004 - Rafael dos Santos Lopes                                       */
/*                                                                            */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_VALOROSSA'  and
            type = 'TR'                       and
            u.uid = o.uid                     and
            u.name = USER)
  DROP TRIGGER DTULTATU_VALOROSSA
  GO

CREATE TRIGGER DTULTATU_VALOROSSA
ON VALOROSSA
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                              (SELECT 'VALOROSSA', NULL, 'CDREFEBIBL='+CDREFEBIBL+';IDSEXOOSSA='+IDSEXOOSSA+';
                               IDOSSATURA='+IDOSSATURA+';VRALTUOSINI='+CONVERT(VARCHAR,VRALTUOSINI)+
                               ';VRALTUOSFIN='+CONVERT(VARCHAR, VRALTUOSFIN)+';', GETDATE()
                               FROM DELETED)
   END
   ELSE BEGIN
      UPDATE VALOROSSA
      SET DTULTATUVOSS = GETDATE()
      FROM INSERTED
      WHERE
         (VALOROSSA.CDREFEBIBL  = INSERTED.CDREFEBIBL ) AND
         (VALOROSSA.IDSEXOOSSA  = INSERTED.IDSEXOOSSA ) AND
         (VALOROSSA.IDOSSATURA  = INSERTED.IDOSSATURA ) AND
         (VALOROSSA.VRALTUOSINI = INSERTED.VRALTUOSINI) AND
         (VALOROSSA.VRALTUOSFIN = INSERTED.VRALTUOSFIN)
   END;
END;
GO
